package com.muzhi.zhizhong.controller;

import com.alibaba.fastjson.JSONObject;
import com.muzhi.zhizhong.common.R;
import com.muzhi.zhizhong.service.DingOaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;


@Api(description = "钉钉人事")
@RestController
@RequestMapping("/dingservice")
@CrossOrigin//解决跨域问题
public class DingOaController {

    @Autowired
    private DingOaService dingOaService;

    //获取map集合参数
    @ApiOperation(value = "获取map集合参数")
    @GetMapping("getJsonStr")
    public String getJsonStr(){

        String jsonStr = dingOaService.getJsonStr();
        System.out.println(jsonStr);

        return jsonStr;
    }

    //创建钉钉OA审批：采购订单【传json格式参数】
    @ApiOperation(value = "创建钉钉OA审批：采购订单")
    @PostMapping("createPuOrder")
    @ResponseBody
    public R createPuOrder(@RequestBody JSONObject body) throws Exception{

        R puOrder = dingOaService.createPuOrder(body);
        System.out.println(puOrder);

        return puOrder;
    }

//    //创建钉钉OA审批：采购订单【传jsonStr格式参数】
//    @ApiOperation(value = "创建钉钉OA审批：采购订单")
//    @PostMapping("createPuOrder")
//    public R createPuOrder(String jsonStr) throws Exception{
//
//        R puOrder = dingOaService.createPuOrder(jsonStr);
//        System.out.println(puOrder);
//
//        return puOrder;
//    }

    //创建钉钉OA审批：销售订单【传json格式参数】
    @ApiOperation(value = "创建钉钉OA审批：销售订单")
    @PostMapping("createSaOrder")
    public R createSaOrder(@RequestBody JSONObject body) throws Exception{

        R saOrder = dingOaService.createSaOrder(body);
        System.out.println(saOrder);

        return saOrder;
    }

//    //创建钉钉OA审批：销售订单【传jsonStr格式参数】
//    @ApiOperation(value = "创建钉钉OA审批：销售订单")
//    @PostMapping("createSaOrder")
//    public R createSaOrder(String jsonStr) throws Exception{
//
//        R saOrder = dingOaService.createSaOrder(jsonStr);
//        System.out.println(saOrder);
//
//        return saOrder;
//    }

    //附件上传
    @ApiOperation(value = "附件上传")
    @PostMapping("addFile")
    public R addFile(String download_url,String userid) throws Exception{

        R s = dingOaService.addFile(download_url,userid);
        System.out.println(s);

        return s;
    }

    //定时同步钉钉审批单状态至U8C
    @ApiOperation(value = "定时同步钉钉审批单状态至U8C")
    @PostMapping("timerStatus")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0/30 * * * * ?")//每30秒触发一次
//    @Scheduled(cron = "0 0/1 * * * ?")//每1分钟触发一次
    public R timerStatus(){

        R s = dingOaService.timerStatus();
        R r = dingOaService.timerStatusPDF();
        System.out.println(r);

        return r;
    }

    //定时同步钉钉审批单合同附件签署状态至U8C
    @ApiOperation(value = "定时同步钉钉审批单合同附件签署状态至U8C")
    @PostMapping("timerStatusPDF")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0/30 * * * * ?")//每30秒触发一次
//    @Scheduled(cron = "0 0/1 * * * ?")//每1分钟触发一次
    public R timerStatusPDF(){

        R s = dingOaService.timerStatusPDF();
        System.out.println(s);

        return s;
    }
}