package com.muzhi.zhizhong.controller;


import com.muzhi.zhizhong.common.R;
import com.muzhi.zhizhong.service.TongbuService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;

@Api(description = "同步数据至数据库")
@RestController
@RequestMapping("/tongbuservice")
@CrossOrigin//解决跨域问题
public class TongbuController {

    @Autowired
    private TongbuService tongbuService;

    //删除employee表中的所有数据
    @ApiOperation(value = "删除employee表中的所有数据")
    @PostMapping("removeEmployee")
    public R removeEmployee(){
        String result = tongbuService.removeEmployee();
        return R.ok().data("result", result);
    }

    //同步花名册数据至数据库
    @ApiOperation(value = "同步花名册数据至数据库")
    @PostMapping("addHuamingce")
//    @Scheduled(cron = "0 1 15 * * ?")//每天下午15：01触发（也就是下午3点触发）
    @Scheduled(cron = "0 0 0 * * ?")//每天00：00触发（也就是凌晨0点整触发）
    public R addHuamingce(){
        //先删除清空employee表中的所有数据
        tongbuService.removeEmployee();

        //再执行插入花名册数据库表的接口
        String result = tongbuService.addHuamingce();
        return R.ok().data("result", result);
    }
}
