package com.muzhi.zhizhong.service.impl;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.dingtalkstorage_1_0.models.CommitFileResponse;
import com.aliyun.dingtalkstorage_1_0.models.GetFileUploadInfoResponse;
import com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiProcessinstanceCreateRequest;
import com.dingtalk.api.request.OapiProcessinstanceCspaceInfoRequest;
import com.dingtalk.api.request.OapiV2UserGetRequest;
import com.dingtalk.api.response.OapiProcessinstanceCreateResponse;
import com.dingtalk.api.response.OapiProcessinstanceCspaceInfoResponse;
import com.dingtalk.api.response.OapiV2UserGetResponse;
import com.muzhi.zhizhong.common.R;
import com.muzhi.zhizhong.entity.EmpZhizhong;
import com.muzhi.zhizhong.entity.StateZhizhong;
import com.muzhi.zhizhong.mapper.EmpZhizhongMapper;
import com.muzhi.zhizhong.mapper.StateZhizhongMapper;
import com.muzhi.zhizhong.service.AccessTokenService;
import com.muzhi.zhizhong.service.DingOaService;
import com.taobao.api.ApiException;
import lombok.extern.slf4j.Slf4j;
import okhttp3.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.text.SimpleDateFormat;
import java.util.*;


@Service
@Slf4j
public class DingOaServiceImpl implements DingOaService {

    @Autowired
    private AccessTokenService accessTokenService;

    //智众人员信息表
    @Autowired
    private EmpZhizhongMapper empZhizhongMapper;

    //智众同步记录表
    @Autowired
    private StateZhizhongMapper stateZhizhongMapper;

    //审批附件id
    public static String fileId = null;
    //审批附件名称
    public static String fileName = null;
    //审批附件长度
    public static Long fileSize = 0L;
    //审批附件类型
    public static String fileType = null;
    //审批钉盘空间id
    public static String spaceId = null;

    @Override
    public String getJsonStr(){

        Map map = new HashMap();
        //创建人姓名
        map.put("name","这是一个创建人姓名");
        //采购订单编号
        map.put("pu_order_code","CG-20221130-000001");
        //供应商名称
        map.put("su_name","这是一个供应商名称");
        //付款协议
        map.put("ag_payment","这是一个付款协议");
        //合同金额
        map.put("am_contract","123456");
        //备注
        map.put("note","这是一个备注");
        //采购类型
        map.put("pu_type","库存商品");
        //申请日期
        map.put("order_date","2022-11-30");

        Map detailMap = new HashMap();
        //存货名称
        detailMap.put("stock_name","这是一个物品名称A");
        //数量
        detailMap.put("stock_num","5");
        //含税单价
        detailMap.put("unit_price","6000.66");
        //价税合计【OA审批中自动计算】
//        detailMap.put("total_price","");

        Map detailMap1 = new HashMap();
        //存货名称
        detailMap1.put("stock_name","这是一个物品名称B");
        //数量
        detailMap1.put("stock_num","10");
        //含税单价
        detailMap1.put("unit_price","5000.55");
        //价税合计【OA审批中自动计算】
//        detailMap.put("total_price","");

        List list = new ArrayList();
        list.add(detailMap);
        list.add(detailMap1);

        map.put("detail",list);
        System.out.println("参数信息：" + map);

        String jsonStr = JSON.toJSONString(map);

        return jsonStr;
    }

    @Override
    public R createPuOrder(JSONObject body) throws Exception{

        //TODO 建立数据库（人员信息表、同步记录表）【***完成人员信息表***】
        //TODO 要完善接口返回参数（成功结果、失败结果：包括失败原因）【***完成***】
        //TODO 拉取智众钉钉组织架构的人员信息（人员编号、姓名、部门编号、部门名称）【***完成***】

        //TODO 上传合同文件到钉钉审批钉盘，获取文件id，放入创建审批单对应参数中

        //System.out.println("接口入参jsonStr：" + jsonStr);
        log.info("开始接收U8C传递参数......");
//        log.info("接收U8C传递jsonStr请求参数：" + jsonStr);
        log.info("接收U8C传递json请求参数：" + body);

        log.info("开始解析请求参数......");
//        JSONObject jsonObject = JSON.parseObject(jsonStr);

        String noteGet = null;
        String note = null;

        String order_date = null;
        String am_contract = null;

        String ag_paymentGet = null;
        String ag_payment = null;

        String pu_type = null;
        String name = null;
        String pu_order_code = null;
        String su_name = null;

        //唯一编码
        String pk = null;

        //文件下载地址
        String download_url = null;

        try {
            //备注
            noteGet = body.getString("note");
            if (noteGet == null){
                note = "";
            }else {
                note = noteGet;
            }
            System.out.println("备注：" + note);

            //申请日期
            order_date = body.getString("order_date");
            System.out.println("申请日期：" + order_date);
            //合同金额
            am_contract = body.getString("am_contract");
            System.out.println("合同金额：" + am_contract);

            //付款协议
            ag_paymentGet = body.getString("ag_payment");
            if (ag_paymentGet == null){
                ag_payment = "";
            }else {
                ag_payment = ag_paymentGet;
            }
            System.out.println("付款协议：" + ag_payment);

            //采购类型
            pu_type = body.getString("pu_type");
            System.out.println("采购类型：" + pu_type);
            //创建人姓名
            name = body.getString("name");
            System.out.println("创建人姓名：" + name);
            //采购订单编号
            pu_order_code = body.getString("pu_order_code");
            System.out.println("采购订单编号：" + pu_order_code);
            //供应商名称
            su_name = body.getString("su_name");
            System.out.println("供应商名称：" + su_name);

            //唯一编码
            pk = body.getString("pk");
            System.out.println("唯一编码：" + pk);

            //文件下载地址
            download_url = body.getString("download_url");
            System.out.println("文件下载地址：" + download_url);
        }catch (Exception e){
            e.printStackTrace();
        }


        /*判断数据库中是否存在该人员，并查询人员id和部门id*/
        String userid = null;
        String bumenid = null;
        long deptid = -1L;
        try {
            QueryWrapper<EmpZhizhong> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("name", name);

            //人员id
            userid = empZhizhongMapper.selectOne(queryWrapper).getUserid();
            //部门id，并转换成long型
            bumenid = empZhizhongMapper.selectOne(queryWrapper).getDeptid();
            deptid = Long.parseLong(bumenid);
            System.out.println("查询数据库中的存在的钉钉人员userid：" + userid);
            System.out.println("查询数据库中的存在的钉钉人员部门id：" + deptid);
        }catch (Exception e){
            e.printStackTrace();
        }
        /*判断数据库中是否存在该人员，并查询人员id和部门id*/


        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/processinstance/create");
        OapiProcessinstanceCreateRequest req = new OapiProcessinstanceCreateRequest();
        //自建应用的AgentId
        req.setAgentId(2121466878L);
        //TODO 审批模板processCode  采购申请单TEST
        req.setProcessCode("PROC-C897D925-5856-4200-BB0E-2AC03A1CBD60");
        //发起人userid
        req.setOriginatorUserId(userid);
        //发起人部门id（long型）
        req.setDeptId(deptid);


        List<OapiProcessinstanceCreateRequest.FormComponentValueVo> formComponentValueVoList = new ArrayList<>();

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo);
        formComponentValueVo.setName("采购订单号");
        formComponentValueVo.setValue(pu_order_code);

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo1 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo1);
        formComponentValueVo1.setName("订单来源");
        formComponentValueVo1.setValue("线上同步");

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo2 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo2);
        formComponentValueVo2.setName("供应商名称");
        formComponentValueVo2.setValue(su_name);

        //单选框组件
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo5 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo5);
        formComponentValueVo5.setName("采购类型");
        formComponentValueVo5.setValue(pu_type);

        //日期组件
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo6 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo6);
        formComponentValueVo6.setName("申请日期");
        formComponentValueVo6.setValue(order_date);

        //单行文本
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo7 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo7);
        formComponentValueVo7.setName("付款协议");
        formComponentValueVo7.setValue(ag_payment);

        //多行文本
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo8 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo8);
        formComponentValueVo8.setName("备注");
        formComponentValueVo8.setValue(note);

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo9 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo9);
        formComponentValueVo9.setName("合同金额");
        formComponentValueVo9.setValue(am_contract);

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo10 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo10);
        formComponentValueVo10.setName("唯一编码");
        formComponentValueVo10.setValue(pk);

        /*调用上传附件到审批钉盘，并获取文件id接口*/

        R r = addFile(download_url, userid);
        Integer FileCode = r.getCode();
        if (FileCode == 200){
            //上传审批附件
            OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo11 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
            formComponentValueVoList.add(formComponentValueVo11);
            JSONObject jsonObjectSP = new JSONObject();
            jsonObjectSP.put("spaceId", spaceId);
            jsonObjectSP.put("fileName", fileName);
            jsonObjectSP.put("fileSize", fileSize);
            jsonObjectSP.put("fileType", fileType);
            jsonObjectSP.put("fileId", fileId);
            Object o[] = new Object[]{jsonObjectSP};
            String s = JSON.toJSONString(o);
            formComponentValueVo11.setName("附件");
            formComponentValueVo11.setValue(s);
        }else {
            String message = r.getMessage();
            System.out.println("获取文件id失败消息：" + message);
        }

        //明细列表
        List listAll = new ArrayList();
        JSONArray detail = null;
        try {
            detail = body.getJSONArray("detail");
            for (int i = 0; i < detail.size(); i++) {
                //存货名称
                String stock_name = detail.getJSONObject(i).getString("stock_name");
                System.out.println("存货名称：" + stock_name);
                //数量
                String stock_num = detail.getJSONObject(i).getString("stock_num");
                System.out.println("数量：" + stock_num);
                //含税单价
                String unit_price = detail.getJSONObject(i).getString("unit_price");
                System.out.println("含税单价：" + unit_price);

                Map map = new HashMap();
                map.put("name","品牌/名称/规格");
                map.put("value",stock_name);

                Map map1 = new HashMap();
                map1.put("name","数量");
                map1.put("value",stock_num);

                Map map2 = new HashMap();
                map2.put("name","参考单价");
                map2.put("value",unit_price);

                List list = new ArrayList();
                list.add(map);
                list.add(map1);
                list.add(map2);

                listAll.add(list);
            }
        }catch (Exception e){
            e.printStackTrace();
        }

        String jsonString = JSON.toJSONString(listAll);
//        System.out.println("明细列表最终的jsonString：" + jsonString);
        log.info("明细列表最终的jsonString：" + jsonString);

        //明细
        if (detail != null){
            OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo12 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
            formComponentValueVo12.setName("明细");
            formComponentValueVo12.setValue(jsonString);
//        System.out.println("JSON转换：" + JSON.toJSONString(Arrays.asList(Arrays.asList(Item1, Item2, Item3),Arrays.asList(Item11, Item22, Item33))));
            formComponentValueVoList.add(formComponentValueVo12);
        }

        log.info("开始创建钉钉OA审批......");
        req.setFormComponentValues(formComponentValueVoList);
        OapiProcessinstanceCreateResponse rsp = client.execute(req, accessTokenService.getAccessToken());
        log.info("创建OA审批响应结果：" + JSON.toJSONString(rsp));

        String result = JSON.toJSONString(rsp);
        JSONObject jsonObject1 = JSON.parseObject(result);
        String success = jsonObject1.getString("success");
        //钉钉OA审批接口响应结果
        //钉钉OA审批实例id
        String processInstanceId = jsonObject1.getString("processInstanceId");
        //错误信息
        String errmsg = jsonObject1.getString("errmsg");


        //封装错误响应data
        Map map = new HashMap();
        //采购订单编号
        if (pu_order_code == null){
            map.put("pu_order_code","未找到该参数");
        }
        //姓名
        if (name == null){
            map.put("name","未找到该参数");
        }
        //供应商名称
        if (su_name == null){
            map.put("su_name","未找到该参数");
        }
        //合同金额
        if (am_contract == null){
            map.put("am_contract","未找到该参数");
        }
        //采购类型
        if (pu_type == null){
            map.put("pu_type","未找到该参数");
        }
        //申请日期
        if (order_date == null){
            map.put("order_date","未找到该参数");
        }
        //明细列表
        if (detail == null){
            map.put("detail","未找到该参数");
        }

        //唯一编码
        if (pk == null){
            map.put("pk","未找到该参数");
        }

        //文件下载地址
        if (download_url == null){
            map.put("download_url","未找到该参数");
        }

        //记录同步情况
        StateZhizhong stateZhizhong = new StateZhizhong();

        if (name != null & userid == null){

            return R.error().message("该人员姓名在钉钉中不存在").data("pu_order_code",pu_order_code).data("name",name);
        }else if (name == null || pu_order_code == null || su_name == null || am_contract == null ||
                pu_type == null || order_date == null || detail == null || pk == null || download_url == null){

            return R.error().message("请求参数必填信息有误").data("error",map);
        }else if (success.equals("false")){

            return R.error().message(errmsg).data("pu_order_code",pu_order_code).data("name",name);
        }else{
            stateZhizhong.setType("采购订单");
            stateZhizhong.setPk(pk);
            stateZhizhong.setProcessid(processInstanceId);
            stateZhizhong.setOrderid(pu_order_code);
            stateZhizhong.setState("同步成功");
            stateZhizhong.setStatus("审批中");
            stateZhizhongMapper.insert(stateZhizhong);

            return R.ok().data("processInstanceId",processInstanceId);
        }

    }

    @Override
    public R createSaOrder(JSONObject body) throws Exception{

        //System.out.println("接口入参jsonStr：" + jsonStr);
        log.info("开始接收U8C传递参数......");
//        log.info("接收U8C传递jsonStr请求参数：" + jsonStr);
        log.info("接收U8C传递json请求参数：" + body);

        log.info("开始解析请求参数......");
//        JSONObject jsonObject = JSON.parseObject(jsonStr);

        String noteGet = null;
        String note = null;

        String order_date = null;
        String yn_stock = null;

        String co_person = null;
        String ow_project = null;
        String name = null;
        String sa_order_code = null;
        String customer_name = null;

        //文件下载地址
        String download_url = null;

        //唯一编码
        String pk = null;

        try {
            //备注
            noteGet = body.getString("note");
            if (noteGet == null){
                note = "";
            }else {
                note = noteGet;
            }
            System.out.println("备注：" + note);

            //申请日期
            order_date = body.getString("order_date");
            System.out.println("申请日期：" + order_date);
            //是否囤货
            yn_stock = body.getString("yn_stock");
            System.out.println("是否囤货：" + yn_stock);

            //联系人/销售
            co_person = body.getString("co_person");
            System.out.println("联系人/销售：" + co_person);

            //所属项目
            ow_project = body.getString("ow_project");
            System.out.println("所属项目：" + ow_project);
            //创建人姓名
            name = body.getString("name");
            System.out.println("创建人姓名：" + name);
            //销售订单编号
            sa_order_code = body.getString("sa_order_code");
            System.out.println("销售订单编号：" + sa_order_code);
            //对方单位名称/客户名称
            customer_name = body.getString("customer_name");
            System.out.println("对方单位名称/客户名称：" + customer_name);

            //文件下载地址
            download_url = body.getString("download_url");
            System.out.println("文件下载地址：" + download_url);

            //唯一编码
            pk = body.getString("pk");
            System.out.println("唯一编码：" + pk);
        }catch (Exception e){
            e.printStackTrace();
        }


        /*判断数据库中是否存在该人员，并查询人员id和部门id*/
        String userid = null;
        String bumenid = null;
        long deptid = -1L;
        try {
            QueryWrapper<EmpZhizhong> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("name", name);

            //人员id
            userid = empZhizhongMapper.selectOne(queryWrapper).getUserid();
            //部门id，并转换成long型
            bumenid = empZhizhongMapper.selectOne(queryWrapper).getDeptid();
            deptid = Long.parseLong(bumenid);
            System.out.println("查询数据库中的存在的钉钉人员userid：" + userid);
            System.out.println("查询数据库中的存在的钉钉人员部门id：" + deptid);
        }catch (Exception e){
            e.printStackTrace();
        }
        /*判断数据库中是否存在该人员，并查询人员id和部门id*/

        /*判断数据库中是否存在该销售人员，并查询人员id和部门id*/
        String userid_person = null;
        try {
            QueryWrapper<EmpZhizhong> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("name", co_person);

            //销售人员id
            userid_person = empZhizhongMapper.selectOne(queryWrapper).getUserid();
            System.out.println("查询数据库中的存在的钉钉销售人员userid_person：" + userid_person);
        }catch (Exception e){
            e.printStackTrace();
        }
        /*判断数据库中是否存在该销售人员，并查询人员id和部门id*/


        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/processinstance/create");
        OapiProcessinstanceCreateRequest req = new OapiProcessinstanceCreateRequest();
        //自建应用的AgentId
        req.setAgentId(2121466878L);
        //TODO 审批模板processCode  销售审批合同TEST
        req.setProcessCode("PROC-67912B9E-E328-469E-BF1A-0578297B49B1");
        //发起人userid
        req.setOriginatorUserId(userid);
        //发起人部门id（long型）
        req.setDeptId(deptid);


        List<OapiProcessinstanceCreateRequest.FormComponentValueVo> formComponentValueVoList = new ArrayList<>();

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo);
        formComponentValueVo.setName("销售订单号");
        formComponentValueVo.setValue(sa_order_code);

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo1 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo1);
        formComponentValueVo1.setName("订单来源");
        formComponentValueVo1.setValue("线上同步");

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo2 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo2);
        formComponentValueVo2.setName("客户名称");
        formComponentValueVo2.setValue(customer_name);

        //单选框组件
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo5 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo5);
        formComponentValueVo5.setName("BU");
        formComponentValueVo5.setValue(ow_project);

        //日期组件
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo6 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo6);
        formComponentValueVo6.setName("申请日期");
        formComponentValueVo6.setValue(order_date);

        //联系人
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo7 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo7);
        formComponentValueVo7.setName("联系人");
        formComponentValueVo7.setValue("[\"" + userid_person + "\"]");

        //多行文本
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo8 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo8);
        formComponentValueVo8.setName("备注");
        formComponentValueVo8.setValue(note);

        //单选框组件
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo9 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo9);
        formComponentValueVo9.setName("订单状态");
        formComponentValueVo9.setValue(yn_stock);

        //单行输入框
        OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo11 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
        formComponentValueVoList.add(formComponentValueVo11);
        formComponentValueVo11.setName("唯一编码");
        formComponentValueVo11.setValue(pk);


        /*调用上传附件到审批钉盘，并获取文件id接口*/

        R r = addFile(download_url, userid);
        Integer FileCode = r.getCode();
        if (FileCode == 200){
            //上传审批附件
            OapiProcessinstanceCreateRequest.FormComponentValueVo formComponentValueVo10 = new OapiProcessinstanceCreateRequest.FormComponentValueVo();
            formComponentValueVoList.add(formComponentValueVo10);
            JSONObject jsonObjectSP = new JSONObject();
            jsonObjectSP.put("spaceId", spaceId);
            jsonObjectSP.put("fileName", fileName);
            jsonObjectSP.put("fileSize", fileSize);
            jsonObjectSP.put("fileType", fileType);
            jsonObjectSP.put("fileId", fileId);
            Object o[] = new Object[]{jsonObjectSP};
            String s = JSON.toJSONString(o);
            formComponentValueVo10.setName("附件");
            formComponentValueVo10.setValue(s);
        }else {
            String message = r.getMessage();
            System.out.println("获取文件id失败消息：" + message);
        }

        log.info("开始创建钉钉OA审批......");
        req.setFormComponentValues(formComponentValueVoList);
        OapiProcessinstanceCreateResponse rsp = client.execute(req, accessTokenService.getAccessToken());
        log.info("创建OA审批响应结果：" + JSON.toJSONString(rsp));

        String result = JSON.toJSONString(rsp);
        JSONObject jsonObject1 = JSON.parseObject(result);
        String success = jsonObject1.getString("success");
        //钉钉OA审批接口响应结果
        //钉钉OA审批实例id
        String processInstanceId = jsonObject1.getString("processInstanceId");
        //错误信息
        String errmsg = jsonObject1.getString("errmsg");


        //封装错误响应data
        Map map = new HashMap();
        //销售订单编号
        if (sa_order_code == null){
            map.put("sa_order_code","未找到该参数");
        }
        //姓名
        if (name == null){
            map.put("name","未找到该参数");
        }
        //联系人
        if (co_person == null){
            map.put("co_person","未找到该参数");
        }
        //对方单位名称/客户名称
        if (customer_name == null){
            map.put("customer_name","未找到该参数");
        }
        //所属项目
        if (ow_project == null){
            map.put("ow_project","未找到该参数");
        }
        //是否囤货
        if (yn_stock == null){
            map.put("yn_stock","未找到该参数");
        }
        //订单日期
        if (order_date == null){
            map.put("order_date","未找到该参数");
        }

        //文件下载地址
        if (download_url == null){
            map.put("download_url","未找到该参数");
        }

        //唯一编码
        if (pk == null){
            map.put("pk","未找到该参数");
        }

        //记录同步情况
        StateZhizhong stateZhizhong = new StateZhizhong();

        if (name != null & userid == null){

            return R.error().message("该人员姓名在钉钉中不存在").data("sa_order_code",sa_order_code).data("name",name);
        }else if (co_person != null & userid_person == null){

            return R.error().message("该销售人员姓名在钉钉中不存在").data("sa_order_code",sa_order_code).data("co_person",co_person);
        } else if (name == null || sa_order_code == null || customer_name == null || ow_project == null ||
                yn_stock == null || order_date == null || co_person == null || download_url == null || pk == null){

            return R.error().message("请求参数必填信息有误").data("error",map);
        }else if (FileCode == 201){

            return R.error().message("未获取到文件id，附件上传失败！").data("download_url",download_url);
        } else if (success.equals("false")){

            return R.error().message(errmsg).data("sa_order_code",sa_order_code).data("name",name);
        }else{
            stateZhizhong.setType("销售订单");
            stateZhizhong.setPk(pk);
            stateZhizhong.setProcessid(processInstanceId);
            stateZhizhong.setOrderid(sa_order_code);
            stateZhizhong.setState("同步成功");
            stateZhizhong.setStatus("审批中");
            stateZhizhongMapper.insert(stateZhizhong);

            return R.ok().data("processInstanceId",processInstanceId);
        }
    }


    /*附件上传审批钉盘*/
    //文件下载保存方法
    @SuppressWarnings("finally")
    public static File downloadFile(String urlPath, String downloadDir) {
        File file = null;
        try {

            URL url = new URL(urlPath);

            URLConnection urlConnection = url.openConnection();

            HttpURLConnection httpURLConnection = (HttpURLConnection) urlConnection;// http的连接类

            //String contentType = httpURLConnection.getContentType();//请求类型,可用来过滤请求，

            httpURLConnection.setConnectTimeout(1000*5);//设置超时

            httpURLConnection.setRequestMethod("GET");//设置请求方式，默认是GET

            httpURLConnection.setRequestProperty("Charset", "UTF-8");// 设置字符编码


            httpURLConnection.connect();// 打开连接

            BufferedInputStream bin = new BufferedInputStream(httpURLConnection.getInputStream());

            //TODO 修改成动态文件名称：当前审批单的文件名称
//            String fileName = "ceshi.pdf";// 指定文件名称
            File tempFile =new File(urlPath.trim());
            fileName = tempFile.getName();
            System.out.println("fileName = " + fileName);

            String path = downloadDir + File.separatorChar + fileName;// 指定存放位置，此处使用的是全局变量的文件名称
            file = new File(path);
            // 校验文件夹目录是否存在，不存在就创建一个目录
            if (!file.getParentFile().exists()) {
                file.getParentFile().mkdirs();
            }

            OutputStream out = new FileOutputStream(file);
            int size = 0;

            byte[] b = new byte[2048];
            //把输入流的文件读取到字节数据b中，然后输出到指定目录的文件
            while ((size = bin.read(b)) != -1) {
                out.write(b, 0, size);
            }
            // 关闭资源
            bin.close();
            out.close();
            System.out.println("文件下载成功！");
        } catch (MalformedURLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            System.out.println("文件下载失败！");
        } finally {
            return file;
        }

    }

    public static com.aliyun.dingtalkstorage_1_0.Client createClientFile() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkstorage_1_0.Client(config);
    }

    //附件上传
    @Override
    public R addFile(String download_url,String userid) throws Exception{

        log.info("开始接收U8C传递文件url参数......");
        log.info("接收U8C传递文件下载地址url请求参数：" + download_url);
        log.info("接收U8C传递人员userid请求参数：" + userid);

        //文件下载地址
//        download_url = "https://mc.cloudpure.cn/portal/aliwork/love.pdf";

        //获取当前日期，用于创建文件保存目录中增加当前日期的文件夹作区分
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");//设置日期格式 yyyy-MM-dd HH:mm:ss
        String format = df.format(new Date());
        System.out.println("系统当前日期（创建本地文件夹）：" + format);// new Date()为获取当前系统时间

        //参数1：文件下载地址；
        //参数2：文件下载后保存地址；
        //【windows端下载文件保存路径】
//        File file = downloadFile(download_url, "D:\\pdf\\" + format);

        //【Linux端下载文件保存路径】
        File file = downloadFile(download_url, format);

        System.out.println("&&&&&&&&&&&&&&&&&" + file);
        if (file != null){
            fileSize = file.length();
            System.out.println("文件长度：" + fileSize);
            fileName = file.getName();
            System.out.println("文件名称：" + fileName);
            //截取文件全名最后一个小数点后面的文件后缀（文件类型）
            fileType = fileName.substring(fileName.lastIndexOf(".") + 1,fileName.length());
            System.out.println("文件类型：" + fileType);
        }else {
            System.out.println("文件下载地址有误！");
        }

        //【Linux下面的路径】
        //原始文件路径
        String strFileLinux = format + File.separator + fileName;
        System.out.println("Linux下面的路径：" + strFileLinux);

        //【windows下面的路径】
        //原始文件路径
        String strFileWindows = "D:\\pdf\\" + format + "\\" + fileName;
        System.out.println("windows下面的路径：" + strFileWindows);

        //***获取审批钉盘空间信息（企业审批附件钉盘空间，需通过获取审批钉盘空间信息接口进行【授权】）***
        String space_XX = null;

        try {
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/processinstance/cspace/info");
            OapiProcessinstanceCspaceInfoRequest req = new OapiProcessinstanceCspaceInfoRequest();
            //用户id
            req.setUserId(userid);
            //企业应用标识，此处可以不传
//            req.setAgentId(2121466878L);
            OapiProcessinstanceCspaceInfoResponse rsp = client.execute(req, accessTokenService.getAccessToken());
            space_XX = rsp.getBody();
            System.out.println(rsp.getBody());
        } catch (ApiException e) {
            e.printStackTrace();
        }

        JSONObject jsonObject_space = JSON.parseObject(space_XX);
        JSONObject result_space = jsonObject_space.getJSONObject("result");
        spaceId = result_space.getString("space_id");
        System.out.println("审批钉盘空间id：" + spaceId);

        //获取当前人员的unionid
        String unionid = null;
        try {
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/v2/user/get");
            OapiV2UserGetRequest req = new OapiV2UserGetRequest();
            //待查询的人员userid
            req.setUserid(userid);
            OapiV2UserGetResponse rsp = client.execute(req, accessTokenService.getAccessToken());
            String result = rsp.getBody();
            System.out.println(result);
            unionid = JSON.parseObject(result).getJSONObject("result").getString("unionid");
            System.out.println("获取的人员unionid：" + unionid);
        } catch (ApiException e) {
            e.printStackTrace();
        }

        /*获取文件上传信息*/
        JSONObject jsonObject = null;
        try {
            com.aliyun.dingtalkstorage_1_0.Client client = createClientFile();
            com.aliyun.dingtalkstorage_1_0.models.GetFileUploadInfoHeaders getFileUploadInfoHeaders = new com.aliyun.dingtalkstorage_1_0.models.GetFileUploadInfoHeaders();
            getFileUploadInfoHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();

            com.aliyun.dingtalkstorage_1_0.models.GetFileUploadInfoRequest getFileUploadInfoRequest = new com.aliyun.dingtalkstorage_1_0.models.GetFileUploadInfoRequest()
                    //人员unionid
                    .setUnionId(unionid)
                    //通过指定上传协议返回不同协议上传所需要的信息。
                    //HEADER_SIGNATURE：Header加签
                    .setProtocol("HEADER_SIGNATURE")
                    //是否需要分片上传。
                    //true：需要
                    //false：不需要
                    .setMultipart(false);

            GetFileUploadInfoResponse fileUploadInfoWithOptions = client.getFileUploadInfoWithOptions(spaceId, getFileUploadInfoRequest, getFileUploadInfoHeaders, new RuntimeOptions());
            System.out.println("*************" + JSON.toJSONString(fileUploadInfoWithOptions.getBody()));
            String s = JSON.toJSONString(fileUploadInfoWithOptions.getBody());
            jsonObject = JSON.parseObject(s);
            System.out.println("获取文件上传信息接口object对象：" + jsonObject);
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }

        String uploadKey = null;
        Map map = new HashMap();
        String resourceUrlsString = null;
        try {
            JSONObject headerSignatureInfo = jsonObject.getJSONObject("headerSignatureInfo");

            //uploadKey
            uploadKey = jsonObject.getString("uploadKey");
            System.out.println("uploadKey：" + uploadKey);

            //headers
            JSONObject headersA = headerSignatureInfo.getJSONObject("headers");
            String authorization = headersA.getString("Authorization");
            String xossdate = headersA.getString("x-oss-date");

            map.put("Authorization",authorization);
            map.put("x-oss-date",xossdate);
            System.out.println("headers：" + map);

            //resourceUrl
            JSONArray resourceUrls = headerSignatureInfo.getJSONArray("resourceUrls");
            resourceUrlsString = resourceUrls.getString(0);
            System.out.println("resourceUrl：" + resourceUrlsString);
        }catch (Exception e){
            e.printStackTrace();
        }
        /*获取文件上传信息*/

        /*使用OSS的header加签方式上传文件*/
        // 从接口返回信息中拿到url
        String resourceUrl = resourceUrlsString;
        // 从接口返回信息中拿到headers
        Map<String, String> headers = map;
        try {
            URL url = new URL(resourceUrl);
            HttpURLConnection connection = (HttpURLConnection)url.openConnection();
            if (headers != null) {
                for (Map.Entry<String, String> entry : headers.entrySet()) {
                    connection.setRequestProperty(entry.getKey(), entry.getValue());
                }
            }
            connection.setDoOutput(true);
            connection.setRequestMethod("PUT");
            connection.setUseCaches(false);
            connection.setReadTimeout(10000);
            connection.setConnectTimeout(10000);
            connection.connect();
            OutputStream out = connection.getOutputStream();

            //本地上传文件路径
            InputStream is = new FileInputStream(new File(strFileLinux));

            byte[] b =new byte[1024];
            int temp;
            while ((temp=is.read(b))!=-1){
                out.write(b,0,temp);
            }
            out.flush();
            out.close();
            int responseCode = connection.getResponseCode();
            connection.disconnect();
            if (responseCode == 200) {
                System.out.println("上传成功");
            } else {
                System.out.println("上传失败");
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        /*使用OSS的header加签方式上传文件*/

        /*提交文件，并获取文件id*/
        JSONObject jsonObjectTJ = null;
        try {
            com.aliyun.dingtalkstorage_1_0.Client client = createClientFile();
            com.aliyun.dingtalkstorage_1_0.models.CommitFileHeaders commitFileHeaders = new com.aliyun.dingtalkstorage_1_0.models.CommitFileHeaders();
            commitFileHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
//            com.aliyun.dingtalkstorage_1_0.models.CommitFileRequest.CommitFileRequestOptionAppProperties optionAppProperties0 = new com.aliyun.dingtalkstorage_1_0.models.CommitFileRequest.CommitFileRequestOptionAppProperties()
//                    //属性名。
//                    .setName(fileName)
//                    //属性可见性。
//                    //PUBLIC：所有应用都可见
//                    //PRIVATE：仅限当前应用可见
//                    .setVisibility("PUBLIC")
//                    //属性值。
//                    .setValue("合同附件");
//            com.aliyun.dingtalkstorage_1_0.models.CommitFileRequest.CommitFileRequestOption option = new com.aliyun.dingtalkstorage_1_0.models.CommitFileRequest.CommitFileRequestOption()
//                    //文件大小
//                    .setSize(fileSize)
//                    //文件名称冲突策略。
//                    //AUTO_RENAME：自动重命名，默认值
//                    //OVERWRITE：覆盖
//                    //RETURN_DENTRY_IF_EXISTS：返回已存在文件
//                    //RETURN_ERROR_IF_EXISTS：文件已存在时报错
//                    .setConflictStrategy("AUTO_RENAME")
//                    .setAppProperties(java.util.Arrays.asList(
//                            optionAppProperties0
//                    ));
            com.aliyun.dingtalkstorage_1_0.models.CommitFileRequest commitFileRequest = new com.aliyun.dingtalkstorage_1_0.models.CommitFileRequest()
                    //人员unionid
                    .setUnionId(unionid)
                    //文件的名称，带后缀。
                    .setName(fileName)
                    //添加文件唯一标识。
                    .setUploadKey(uploadKey)
                    //父目录Id。根目录时，该参数是0
                    .setParentId("0");
//                    .setOption(option);

            CommitFileResponse commitFileResponse = client.commitFileWithOptions(spaceId, commitFileRequest, commitFileHeaders, new RuntimeOptions());
            System.out.println("*************" + JSON.toJSONString(commitFileResponse.getBody()));
            String s = JSON.toJSONString(commitFileResponse.getBody());
            jsonObjectTJ = JSON.parseObject(s);
            System.out.println("提交文件接口object对象：" + jsonObjectTJ);
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }

        try {
            JSONObject dentry = jsonObjectTJ.getJSONObject("dentry");
            fileId = dentry.getString("id");
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println("获取的文件id：" + fileId);
        /*提交文件，并获取文件id*/

        if (fileId == null){
            return R.error().message("获取文件id失败！").data("download_url",download_url);
        }else{
            return R.ok().data("FileId",fileId);
        }
    }

    public static com.aliyun.dingtalkworkflow_1_0.Client createClient() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkworkflow_1_0.Client(config);
    }

    //定时同步钉钉审批单状态至U8C
    @Override
    public R timerStatus(){
        log.info("开始执行定时同步【钉钉审批单状态】至U8C...");

        QueryWrapper<StateZhizhong> queryWrapper = new QueryWrapper<>();
        List<StateZhizhong> stateZhizhongList = null;
        try {
            queryWrapper.eq("status", "审批中");

            stateZhizhongList = stateZhizhongMapper.selectList(queryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println("同步记录数据表【审批中】总数：" + stateZhizhongList.size());
        System.out.println("同步记录数据表【审批中】：" + stateZhizhongList);

        if (stateZhizhongList != null){
            for (int i = 0; i < stateZhizhongList.size(); i++) {
                //订单类型
                String type = stateZhizhongList.get(i).getType();
                System.out.println("订单类型：" + type);

                //唯一编号
                String pk = stateZhizhongList.get(i).getPk();
                System.out.println("唯一编码：" + pk);

                //审批实例id
                String processid = stateZhizhongList.get(i).getProcessid();
                System.out.println("审批实例id：" + processid);

                JSONObject jsonObject = null;
                try {
                    com.aliyun.dingtalkworkflow_1_0.Client client = createClient();
                    com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceHeaders getProcessInstanceHeaders = new com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceHeaders();
                    getProcessInstanceHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                    com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceRequest getProcessInstanceRequest = new com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceRequest()
                            //审批实例id
                            .setProcessInstanceId(processid);

                    GetProcessInstanceResponse processInstanceWithOptions = client.getProcessInstanceWithOptions(getProcessInstanceRequest, getProcessInstanceHeaders, new RuntimeOptions());
                    System.out.println("*************" + JSON.toJSONString(processInstanceWithOptions.getBody()));
                    String s = JSON.toJSONString(processInstanceWithOptions.getBody());
                    jsonObject = JSON.parseObject(s);
                    System.out.println("获取审批实例详情接口object对象：" + jsonObject);
                } catch (TeaException err) {
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }

                } catch (Exception _err) {
                    TeaException err = new TeaException(_err.getMessage(), _err);
                    if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                        // err 中含有 code 和 message 属性，可帮助开发定位问题
                    }

                }
                JSONObject result = jsonObject.getJSONObject("result");
                //审批状态
                //NEW：新创建
                //RUNNING：审批中
                //TERMINATED：被终止
                //COMPLETED：完成
                //CANCELED：取消
                String status = result.getString("status");
                System.out.println("当前审批单状态：" + status);

                UpdateWrapper<StateZhizhong> updateWrapper = new UpdateWrapper<>();
                if (status.equals("COMPLETED")){
                    updateWrapper.eq("processid",processid);
                    updateWrapper.set("status","审批完成");
                    stateZhizhongMapper.update(null,updateWrapper);

                    Map map = new HashMap();
                    map.put("pk",pk);
                    map.put("vdef17","审批完成");
                    String mapStr = JSON.toJSONString(map);
                    System.out.println("写入U8C回传状态接口对象：" + mapStr);

                    log.info("开始执行回传U8C【钉钉审批】状态接口>>>>>>>>>>>");
                    OkHttpClient client = new OkHttpClient().newBuilder()
                            .build();
                    MediaType mediaType = MediaType.parse("application/json");
                    if (type.equals("采购订单")){
                        okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                        Request request = new Request.Builder()
                                .url("http://111.111.2.251:8081/service/wbPurchaseOrder")
                                .method("POST", body)
                                .addHeader("Content-Type", "application/json")
                                .build();
                        try {
                            Response response = client.newCall(request).execute();
                            System.out.println("U8C回传状态【采购订单】接口返回信息：" + JSON.toJSONString(response.body()));
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }else if (type.equals("销售订单")){
                        okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                        Request request = new Request.Builder()
                                .url("http://111.111.2.251:8081/service/wbSaleorder")
                                .method("POST", body)
                                .addHeader("Content-Type", "application/json")
                                .build();
                        try {
                            Response response = client.newCall(request).execute();
                            System.out.println("U8C回传状态【销售订单】接口返回信息：" + JSON.toJSONString(response.body()));
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                }else if (status.equals("RUNNING")){
                    updateWrapper.eq("processid",processid);
                    updateWrapper.set("status","审批中");
                    stateZhizhongMapper.update(null,updateWrapper);

                    Map map = new HashMap();
                    map.put("pk",pk);
                    map.put("vdef17","审批中");
                    String mapStr = JSON.toJSONString(map);
                    System.out.println("写入U8C回传状态接口对象：" + mapStr);

                    log.info("开始执行回传U8C【钉钉审批】状态接口>>>>>>>>>>>");
                    OkHttpClient client = new OkHttpClient().newBuilder()
                            .build();
                    MediaType mediaType = MediaType.parse("application/json");
                    if (type.equals("采购订单")){
                        okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                        Request request = new Request.Builder()
                                .url("http://111.111.2.251:8081/service/wbPurchaseOrder")
                                .method("POST", body)
                                .addHeader("Content-Type", "application/json")
                                .build();
                        try {
                            Response response = client.newCall(request).execute();
                            System.out.println("U8C回传状态【采购订单】接口返回信息：" + JSON.toJSONString(response.body()));
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }else if (type.equals("销售订单")){
                        okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                        Request request = new Request.Builder()
                                .url("http://111.111.2.251:8081/service/wbSaleorder")
                                .method("POST", body)
                                .addHeader("Content-Type", "application/json")
                                .build();
                        try {
                            Response response = client.newCall(request).execute();
                            System.out.println("U8C回传状态【销售订单】接口返回信息：" + JSON.toJSONString(response.body()));
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                }else if (status.equals("TERMINATED")){
                    updateWrapper.eq("processid",processid);
                    updateWrapper.set("status","审批被终止");
                    stateZhizhongMapper.update(null,updateWrapper);

                    Map map = new HashMap();
                    map.put("pk",pk);
                    map.put("vdef17","审批被终止");
                    String mapStr = JSON.toJSONString(map);
                    System.out.println("写入U8C回传状态接口对象：" + mapStr);

                    log.info("开始执行回传U8C【钉钉审批】状态接口>>>>>>>>>>>");
                    OkHttpClient client = new OkHttpClient().newBuilder()
                            .build();
                    MediaType mediaType = MediaType.parse("application/json");
                    if (type.equals("采购订单")){
                        okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                        Request request = new Request.Builder()
                                .url("http://111.111.2.251:8081/service/wbPurchaseOrder")
                                .method("POST", body)
                                .addHeader("Content-Type", "application/json")
                                .build();
                        try {
                            Response response = client.newCall(request).execute();
                            System.out.println("U8C回传状态【采购订单】接口返回信息：" + JSON.toJSONString(response.body()));
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }else if (type.equals("销售订单")){
                        okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                        Request request = new Request.Builder()
                                .url("http://111.111.2.251:8081/service/wbSaleorder")
                                .method("POST", body)
                                .addHeader("Content-Type", "application/json")
                                .build();
                        try {
                            Response response = client.newCall(request).execute();
                            System.out.println("U8C回传状态【销售订单】接口返回信息：" + JSON.toJSONString(response.body()));
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                }else if (status.equals("CANCELED")){
                    updateWrapper.eq("processid",processid);
                    updateWrapper.set("status","审批取消");
                    stateZhizhongMapper.update(null,updateWrapper);

                    Map map = new HashMap();
                    map.put("pk",pk);
                    map.put("vdef17","审批取消");
                    String mapStr = JSON.toJSONString(map);
                    System.out.println("写入U8C回传状态接口对象：" + mapStr);

                    log.info("开始执行回传U8C【钉钉审批】状态接口>>>>>>>>>>>");
                    OkHttpClient client = new OkHttpClient().newBuilder()
                            .build();
                    MediaType mediaType = MediaType.parse("application/json");
                    if (type.equals("采购订单")){
                        okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                        Request request = new Request.Builder()
                                .url("http://111.111.2.251:8081/service/wbPurchaseOrder")
                                .method("POST", body)
                                .addHeader("Content-Type", "application/json")
                                .build();
                        try {
                            Response response = client.newCall(request).execute();
                            System.out.println("U8C回传状态【采购订单】接口返回信息：" + JSON.toJSONString(response.body()));
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }else if (type.equals("销售订单")){
                        okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                        Request request = new Request.Builder()
                                .url("http://111.111.2.251:8081/service/wbSaleorder")
                                .method("POST", body)
                                .addHeader("Content-Type", "application/json")
                                .build();
                        try {
                            Response response = client.newCall(request).execute();
                            System.out.println("U8C回传状态【销售订单】接口返回信息：" + JSON.toJSONString(response.body()));
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                }
            }
        }

        return R.ok().message("钉钉审批状态同步U8C完成！");
    }

    //定时同步钉钉审批单合同附件签署状态至U8C
    @Override
    public R timerStatusPDF(){
        log.info("开始执行定时同步【钉钉审批单合同附件签署状态】至U8C...");

        QueryWrapper<StateZhizhong> queryWrapper = new QueryWrapper<>();
        List<StateZhizhong> stateZhizhongList = null;
        try {
            queryWrapper.eq("status", "审批完成");

            stateZhizhongList = stateZhizhongMapper.selectList(queryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        System.out.println("同步记录数据表【审批完成】总数：" + stateZhizhongList.size());
        System.out.println("同步记录数据表【审批完成】：" + stateZhizhongList);

        if (stateZhizhongList != null){
            for (int i = 0; i < stateZhizhongList.size(); i++) {
                //订单类型
                String type = stateZhizhongList.get(i).getType();
                System.out.println("订单类型：" + type);

                //唯一编号
                String pk = stateZhizhongList.get(i).getPk();
                System.out.println("唯一编码：" + pk);

                //审批实例id
                String processid = stateZhizhongList.get(i).getProcessid();
                System.out.println("审批实例id：" + processid);

                if (type.equals("销售订单")) {
                    JSONObject jsonObject = null;
                    try {
                        com.aliyun.dingtalkworkflow_1_0.Client client = createClient();
                        com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceHeaders getProcessInstanceHeaders = new com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceHeaders();
                        getProcessInstanceHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                        com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceRequest getProcessInstanceRequest = new com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceRequest()
                                //审批实例id
                                .setProcessInstanceId(processid);

                        GetProcessInstanceResponse processInstanceWithOptions = client.getProcessInstanceWithOptions(getProcessInstanceRequest, getProcessInstanceHeaders, new RuntimeOptions());
                        System.out.println("*************" + JSON.toJSONString(processInstanceWithOptions.getBody()));
                        String s = JSON.toJSONString(processInstanceWithOptions.getBody());
                        jsonObject = JSON.parseObject(s);
                        System.out.println("获取审批实例详情接口object对象：" + jsonObject);
                    } catch (TeaException err) {
                        if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                            // err 中含有 code 和 message 属性，可帮助开发定位问题
                        }

                    } catch (Exception _err) {
                        TeaException err = new TeaException(_err.getMessage(), _err);
                        if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                            // err 中含有 code 和 message 属性，可帮助开发定位问题
                        }

                    }
                    JSONObject result = jsonObject.getJSONObject("result");
                    JSONArray formComponentValues = result.getJSONArray("formComponentValues");
                    //TODO 审批单中附件的控件固定下标位置，不能随意修改
                    JSONArray value = formComponentValues.getJSONObject(13).getJSONArray("value");
                    //TODO 如果审批附件中存在多个附件，需要开启这个for循环用于逐条抓取附件的签署信息！！！
//                    for (int j = 0; j < value.size(); j++) {
                        //如果e签宝签署了会在附件控件中有这个对象
                        JSONObject eSign = null;
                        try {
                            eSign = value.getJSONObject(0).getJSONObject("eSign");
                            System.out.println("如果e签宝签署了会在附件控件中有这个对象：" + eSign);
                        }catch (Exception e){
                            e.printStackTrace();
                        }

                        if (eSign == null) {
                            System.out.println("附件还没有发起e签宝签署！");
                        } else {
                            //e签宝签署状态：1待发起 2签署中 3签署完成 4拒绝签署
                            String signStatus = eSign.getString("signStatus");
                            System.out.println("e签宝签署状态：" + signStatus);

                            Map map = new HashMap();
                            map.put("pk",pk);

                            UpdateWrapper<StateZhizhong> updateWrapper = new UpdateWrapper<>();
                            updateWrapper.eq("processid", processid);
                            if (signStatus.equals("1")) {
                                map.put("vdef17","待发起");

                                updateWrapper.set("status", "待发起");
                                stateZhizhongMapper.update(null, updateWrapper);
                            } else if (signStatus.equals("2")) {
                                map.put("vdef17","签署中");

                                updateWrapper.set("status", "签署中");
                                stateZhizhongMapper.update(null, updateWrapper);
                            } else if (signStatus.equals("3")) {
                                map.put("vdef17","签署完成");

                                updateWrapper.set("status", "签署完成");
                                stateZhizhongMapper.update(null, updateWrapper);
                            } else if (signStatus.equals("4")) {
                                map.put("vdef17","拒绝签署");

                                updateWrapper.set("status", "拒绝签署");
                                stateZhizhongMapper.update(null, updateWrapper);
                            }


                            String mapStr = JSON.toJSONString(map);
                            System.out.println("写入U8C回传状态接口对象：" + mapStr);

                            log.info("开始执行回传U8C【合同签署】状态接口>>>>>>>>>>>");
                            OkHttpClient client = new OkHttpClient().newBuilder()
                                    .build();
                            MediaType mediaType = MediaType.parse("application/json");
                            okhttp3.RequestBody body = RequestBody.create(mediaType, mapStr);
                            Request request = new Request.Builder()
                                    .url("http://111.111.2.251:8081/service/wbSaleorder")
                                    .method("POST", body)
                                    .addHeader("Content-Type", "application/json")
                                    .build();
                            try {
                                Response response = client.newCall(request).execute();
                                System.out.println("U8C回传状态【销售订单】接口返回信息：" + JSON.toJSONString(response.body()));
                            }catch (Exception e){
                                e.printStackTrace();
                            }
                        }
//                    }
                }
            }
        }

        return R.ok().message("钉钉审批单合同附件签署状态同步U8C完成！");
    }
}
