package com.muzhi.zhizhong.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiSmartworkHrmEmployeeListRequest;
import com.dingtalk.api.request.OapiSmartworkHrmEmployeeQueryonjobRequest;
import com.dingtalk.api.response.OapiSmartworkHrmEmployeeListResponse;
import com.dingtalk.api.response.OapiSmartworkHrmEmployeeQueryonjobResponse;
import com.muzhi.zhizhong.entity.EmpZhizhong;
import com.muzhi.zhizhong.mapper.EmpZhizhongMapper;
import com.muzhi.zhizhong.service.AccessTokenService;
import com.muzhi.zhizhong.service.TongbuService;
import com.taobao.api.ApiException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class TongbuServiceImpl implements TongbuService {

    @Autowired
    private AccessTokenService accessTokenService;

    @Autowired
    private EmpZhizhongMapper empZhizhongMapper;

    public static String employee = null;
    public static String huamingce = null;

    //删除employee表中的所有数据
    @Override
    public String removeEmployee(){
        empZhizhongMapper.delete(null);
        return "清空花名册数据成功！";
    }

    //同步花名册数据至数据库
    @Override
    public String addHuamingce(){

        //在职员工id列表的循环获取
        DingTalkClient client1 = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/queryonjob");
        OapiSmartworkHrmEmployeeQueryonjobRequest request1 = new OapiSmartworkHrmEmployeeQueryonjobRequest();

        //企业在职员工userid列表
        int offset = 0;//分页游标，从0开始
        int size = 50;//分页大小，最大50


        JSONObject result1;

        do {
            List<String> list = new ArrayList<>();

            System.out.println("测试分页值：" + offset);

            try {
                request1.setStatusList("2,3,5,-1");
                request1.setOffset((long) offset);
                request1.setSize((long) size);
                OapiSmartworkHrmEmployeeQueryonjobResponse response1 = client1.execute(request1, accessTokenService.getAccessToken());
                employee = response1.getBody();
                System.out.println(response1.getBody());
            } catch (ApiException e) {
                e.printStackTrace();
            }

            //通过fastjson工具转换成json对象,逐层解析
            JSONObject jsonObject1 = JSON.parseObject(employee);
            result1 = jsonObject1.getJSONObject("result");

            String dataList = result1.getString("data_list");

            //将String数组进行处理，去掉所有的双引号（""）和中括号（[]）
            String dataRes = dataList.replace("\"", "").
                    replaceAll("\\[", "").
                    replaceAll("\\]", "");

            list.add(dataRes);

            String userid1 = list.toString().replace("\"", "").
                    replaceAll("\\[", "").
                    replaceAll("\\]", "");


            //TODO ---原始同步花名册数据至数据库--- //
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/list");
            OapiSmartworkHrmEmployeeListRequest request = new OapiSmartworkHrmEmployeeListRequest();

            try {
                request.setUseridList(userid1);

                //需要获取的花名册字段信息
                //request.setFieldFilterList("sys00-name,sys02-sexType,sys01-employeeStatus,sys00-email,sys03-graduateSchool,sys03-highestEdu,sys00-dept,e3d6dbbd-9265-4f1e-8c58-ac3602e83960,sys03-graduationTime,sys00-mobile,sys02-address,sys02-marriage,sys00-confirmJoinTime,sys00-workPlace,sys00-position,sys01-positionLevel,sys02-politicalStatus,sys03-major,sys02-certNo,sys02-birthTime,sys02-certAddress,sys02-certEndTime,sys02-residenceType,sys01-employeeType,sys04-bankAccountNo,sys04-accountBank,sys09-personalHf,sys05-contractType,sys05-contractCompanyName,ff63191a-45cf-4106-ade0-54f1def7cc55");

                OapiSmartworkHrmEmployeeListResponse response = client.execute(request, accessTokenService.getAccessToken());
                huamingce = response.getBody();
                System.out.println(response.getBody());
            }catch (ApiException e){
                e.printStackTrace();
            }

            //通过fastjson工具转换成json对象,逐层解析
            //将String类型的花名册json数据转换为Object数据对象
            JSONObject jsonObject = JSON.parseObject(huamingce);

            //直接将花名册对象通过Object转换成Array数组格式
            JSONArray resultArray = jsonObject.getJSONArray("result");

            //new一个employee对象
            EmpZhizhong empZhizhong = new EmpZhizhong();

            for (int i = 0; i<resultArray.size(); i++){
                JSONArray fieldListArray = resultArray
                        .getJSONObject(i).getJSONArray("field_list");

                String userid = resultArray.getJSONObject(i).getString("userid");
                System.out.println("员工id：" + userid);

                //将result的每个对象的id放入employee实体类的id字段中
                empZhizhong.setUserid(userid);

                for (int a = 0; a<fieldListArray.size(); a++){
                    String fieldCode = fieldListArray
                            .getJSONObject(a)
                            .getString("field_code");

                    switch (fieldCode){
                        //姓名
                        case "sys00-name":
                            if (fieldListArray.getJSONObject(a).getString("value") != null){
                                System.out.println("***《《《姓名》》》***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                //放入employee表的姓名字段中
                                empZhizhong.setName(fieldListArray.getJSONObject(a).getString("value"));
                            }
                            else{
                                //如果没有则放入空值
                                empZhizhong.setName("");
                            }
                            break;

                        //主部门id
                        case "sys00-mainDeptId":
                            if (fieldListArray.getJSONObject(a).getString("value") != null){
                                System.out.println("***主部门id***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                empZhizhong.setDeptid(fieldListArray.getJSONObject(a).getString("value"));
                            }
                            else{
                                empZhizhong.setDeptid("");
                            }
                            break;

                        //主部门
                        case "sys00-mainDept":
                            if (fieldListArray.getJSONObject(a).getString("value") != null){
                                System.out.println("***主部门***-->" + fieldListArray.getJSONObject(a).getString("value"));

                                empZhizhong.setDeptname(fieldListArray.getJSONObject(a).getString("value"));
                            }
                            else{
                                empZhizhong.setDeptname("");
                            }
                            break;
                    }
                }
                empZhizhongMapper.insert(empZhizhong);
            }
            //TODO ---原始同步花名册数据至数据库--- //


            if (result1.getString("next_cursor") != null) {
                // || result1.getString("data_list") != ""

//                offset = offset + size;
                try {
                    offset = result1.getInteger("next_cursor");
                }catch (Exception e){
                    e.printStackTrace();
                }

            }

        } while (result1.getString("next_cursor") != null);


        return "同步花名册数据成功！";
    }
}
